#include "newCalcFundamental.h"

using namespace std ;

/**
 * @file calcDiffShape.cc
 * @brief 2Ĥ3θ
 * @param shape1 shape2 2Ĥ3
 * @return diff 
 * @author Kento YAMADA
 * @date 2008.11.23
 */
double calcDiffShape( vector< VecC > shape1, vector< VecC > shape2 ) {

  double diff = 0.0 ;  //!< 2Ĥ3θ

  /* бƤɸθΥΥιפ׻ */
  for( unsigned int i = 0; i < shape1.size(); i++ ) {
    diff += norm( shape1[i] - shape2[i] ) ;
  }

  return (diff/(double)shape1.size());
}
