#include "newCalcFundamental.h"

using namespace std ;

/**
 * @file calcNotFixFocus.cc
 * @brief ǤʤξΥη׻
 * @param F ù
 * @param f1, f2 ׻ΥǼ
 * @author Kento YAMADA
 * @date 2008.12.22
 */
void calcNotFixFocus( const Mat F, double &f1, double &f2 ) {

  //!< \mF\mFt  \mFt\mFκǾͭͤФͭ٥ȥ \ve \ve^\prime
  VecC e(3), e_prime(3) ;
  VecC k( 0.0, 0.0, 1.0 ) ;
  double xi, eta ;           //!< ΥѿѴ \xi  \etaOB
  double inSqrt1, inSqrt2 ;  //!< Υ׻ʿ
  Mat H(2,2) ;               //!< ΥΤΥإå

  double kFk = (k, F*k) ;
  double sqFk = sqnorm(F*k) ;
  double sqFtk = sqnorm(~F*k) ;
  double condition ;
  
  
  cout << "# ͳΥ" << endl ;
  condition = 0.1 * ( (sqFk > sqFtk ) ? sqFtk : sqFk ) / f ;

  cout << "# |kFk| : " << kFk << endl ;
  cout << "# 0.1min(||Fk||,||Ftk||)/f0 : " << condition << endl ;

  if( fabs(kFk) < condition ) {
    cout << "# ERROR : |kFk| = 0 ȤʤꡤȤߤʤޤ" << endl ;
    f1 = f2 = f ;
    return ;
  }


  e       = min_eigen_vector( F * ~F ) ;
  e_prime = min_eigen_vector( ~F * F ) ;


  /* ʿͤ˷׻Ƥ */
  xi  = (sqFk-(k,F*~F*F*k)*sqnorm(e_prime%k)/kFk) / (sqnorm(e_prime%k)*sqFtk-(kFk*kFk)) ;
  eta = (sqFtk-(k,F*~F*F*k)*sqnorm(e%k)/kFk)      / (sqnorm(e%k)*sqFk-(kFk*kFk)) ;

  inSqrt1 = 1.0 + xi ;
  inSqrt2 = 1.0 + eta ;

  cout << "# calcNotFixFocus before inSqrt1 : " << inSqrt1 << endl ;
  cout << "# calcNotFixFocus before inSqrt2 : " << inSqrt2 << endl ;


  /* դĤΥξΥȲꤷͤ· */
  H[0][0] = (2.0 * kFk * kFk * kFk * kFk * eta * eta)
          + (4.0 * kFk * kFk * sqFtk * eta)
          + (2.0 * sqFtk * sqFtk)
          - ( (kFk * kFk * eta + sqFtk ) * (kFk * kFk * eta + sqFtk ) ) ;
  H[0][1] = H[1][0]
          = (4.0 * kFk * kFk * kFk * kFk * xi * eta)
          + (4.0 * kFk * kFk * (sqFtk * xi + sqFk * eta))
          + (4.0 * kFk * (k, F*~F*F*k))
          - ( (kFk * kFk * xi + sqFk) * (kFk * kFk * eta + sqFtk) )
          - (kFk * kFk * (kFk * kFk * xi * eta + sqFtk * xi + sqFk * eta + F.sqnorm() * F.sqnorm())) ;
  H[1][1] = (2.0 * kFk * kFk * kFk * kFk * xi * xi)
          + (4.0 * kFk * kFk * sqFk * xi)
          + (2.0 * sqFk * sqFk)
          - ((kFk * kFk * xi + sqFk) * (kFk * kFk * xi + sqFk)) ;

  xi = eta
     = ( ((H[0][0] + H[0][1]) * xi) + ((H[1][1] + H[0][1]) * eta) ) / (H[0][0] + 2.0 * H[0][1] + H[1][1]) ;

  inSqrt1 = 1.0 + xi ;
  inSqrt2 = 1.0 + eta ;

  cout << "# calcNotFixFocus after inSqrt1 : " << inSqrt1 << endl ;
  cout << "# calcNotFixFocus after inSqrt2 : " << inSqrt2 << endl ;


  /* ΥȽ */
  if( inSqrt1 < 0 || inSqrt2 < 0 ) {
    cout << "# ERROR : ʿ椬ˤʤޤ" << endl ;
    cout << "# Υ" << endl ;
    f1 = f2 = f ;
  } else {
    cout << "# ¿Υ" << endl ;

    f1 = f / sqrt( inSqrt1 ) ;
    f2 = f / sqrt( inSqrt2 ) ;
  }
}
