#include "newCalcFundamental.h"

using namespace std;

/**
 * @file calcXi.cc
 * @brief 9٥ȥ \xi ׻
 * @param x1,x2 ׻Ѥб
 * @return xi 9٥ȥ \xi
 * @author Kento YAMADA
 * @date 2008.12.23
 */
VecC calcXi( const VecC h1, const VecC h2, const VecC t1, const VecC t2 ) {

  VecC xi(9) ;  //!< 9٥ȥ \xi

  /* 9٥ȥ \xi ׻ */
  xi[0] = (h1[0] * h2[0]) + (h2[0] * t1[0]) + (h1[0] * t2[0]) ;
  xi[1] = (h1[0] * h2[1]) + (h2[1] * t1[0]) + (h1[0] * t2[1]) ;
  xi[2] = f * (h1[0] + t1[0]) ;
  xi[3] = (h1[1] * h2[0]) + (h2[0] * t1[1]) + (h1[1] * t2[0]) ;
  xi[4] = (h1[1] * h2[1]) + (h2[1] * t1[1]) + (h1[1] * t2[1]) ;
  xi[5] = f * (h1[1] + t1[1]) ;
  xi[6] = f * (h2[0] + t2[0]) ;
  xi[7] = f * (h2[1] + t2[1]) ;
  xi[8] = f * f ;

  return xi ;
}
