#include "newCalcFundamental.h"

using namespace std ;

/**
 * @file calcNotFixFocusAvg.cc
 * @brief ͳΥˡʿͤǾΥ׻
 * @param F ù
 * @param f1, f2 ׻ΥǼ
 * @author Kento YAMADA
 * @date 2009.7.15
 */
void calcNotFixFocusAvg( const Mat F, double &f1, double &f2 ) {

  //!< \mF\mFt  \mFt\mFκǾͭͤФͭ٥ȥ \ve \ve^\prime
  VecC e(3), e_prime(3) ;
  VecC k( 0.0, 0.0, 1.0 ) ;
  double inSqrt1, inSqrt2 ;  //!< Υ׻ʿ

  cout << "# ͳΥ" << endl ;

  e       = min_eigen_vector( F * ~F ) ;
  e_prime = min_eigen_vector( ~F * F ) ;


  /* ʿͤ˷׻Ƥ */
  inSqrt1 = 1 + (
                  (sqnorm(F*k)-(k,F*~F*F*k)*sqnorm(e_prime%k)/(k,F*k)) /
                  (sqnorm(e_prime%k)*sqnorm(~F*k)-(k,F*k)*(k,F*k))
                ) ;
  inSqrt2 = 1 + (
                  (sqnorm(~F*k)-(k,F*~F*F*k)*sqnorm(e%k)/(k,F*k)) /
                  (sqnorm(e%k)*sqnorm(F*k)-(k,F*k)*(k,F*k))
                ) ;


  cout << "# calcNotFixFocus inSqrt1 : " << inSqrt1 << endl ;
  cout << "# calcNotFixFocus inSqrt2 : " << inSqrt2 << endl ;

  /* ʿͤˤʤäϡȽꤹ */
  if( inSqrt1 < 0 || inSqrt2 < 0 ) {
    cout << "# Υ" << endl ;
    f1 = f2 = f ;
  } else {
    cout << "# ¿Υ" << endl ;
    f1 = f / sqrt( inSqrt1 ) ;
    f2 = f / sqrt( inSqrt2 ) ;
    f1 = f2 = (f1+f2)/2.0 ;
  }
}
