#include <iostream>
#include <fstream>
#include "newCalcFundamental.h"

using namespace std ;

/**
 * @file read.cc
 * @brief ե뤫бɤ߹
 * @param filename б򵭽Ҥե̾
 * @param cooridinate ɤ߹бǼ٥
 * @author Kento YAMADA
 * @date 2008.10.31
 */
void read( const char *filename, vector< VecC > &coordinate ) {

  ifstream fin( filename ) ;  //!< ϥե륹ȥ꡼
  VecC input(2) ;  // Ū˺ɸǼ٥ȥ
  string line  ;   // ŪʸǼstring


  while(getline( fin, line ) ) {
    if( sscanf( line.c_str(), "%lf %lf", &input[0], &input[1] ) == 2 ) {
      coordinate.push_back( input ) ;
    }
  }

  fin.close() ;
}


/**
 * @file read.cc
 * @brief ե뤫бɤ߹
 * @param filename б򵭽Ҥե̾(漼եޥå)
 * @param x1, x2 ɤ߹бǼ٥
 * @author Kento YAMADA
 * @date 2008.12.9
 */
void read( const char *filename, vector< VecC > &x1, vector< VecC > &x2 ) {

  ifstream fin( filename) ;    //!< ϥե륹ȥ꡼
  VecC input1(2), input2(2) ;  // Ū˺ɸǼ٥ȥ
  string line ;                // ŪʸǼ


  while( getline( fin, line ) ) {
    if( sscanf( line.c_str(),"(%lf,%lf)--(%lf,%lf)", &input1[0], &input1[1], &input2[0], &input2[1]) == 4 ) {
      x1.push_back( input1 ) ;
      x2.push_back( input2 ) ;
    }
  }

  fin.close() ;
}
