#include "newCalcFundamental.h"

/**
 * @file setFundamental.cc
 * @brief 9ñ̥٥ȥ u ù F ׻
 * @param u ñ̥٥ȥ u
 * @return F ù
 * @author Kento YAMADA
 * @date 2008.10.31
 */
Mat setFundamental( VecC u ) {

  Mat F(3,3) ;  //!< ùF
  F.clear( 0.0 ) ;

  /* ʸ˽äƴù F  */
  F[0][0] = u[0] ;  F[0][1] = u[1] ;  F[0][2] = u[2] ;
  F[1][0] = u[3] ;  F[1][1] = u[4] ;  F[1][2] = u[5] ;
  F[2][0] = u[6] ;  F[2][1] = u[7] ;  F[2][2] = u[8] ;

  //return normalize( F ) ;
  return F ;
}



/**
 * @file setFundamental.cc
 * @brief ù F  9 ñ̥٥ȥ u 
 * @param F ù
 * @return u 9ñ̥٥ȥ u
 * @author Kento YAMADA
 * @date 2009.4.22
 */
VecC setFundamental( Mat F ) {

  VecC u( 9 ) ;  //!< ù F Ǽ 9 ñ̥٥ȥ u
  u.clear( 0.0 ) ;

  /* ʸ˽äƴù F  9 ñ̥٥ȥ u  */
  u[0] = F[0][0];  u[1] = F[0][1];  u[2] = F[0][2];
  u[3] = F[1][0];  u[4] = F[1][1];  u[5] = F[1][2];
  u[6] = F[2][0];  u[7] = F[2][1];  u[8] = F[2][2];

  return u ;
}
