#include "newCalcFundamental.h"
#include <float.h>  // DBL_MAXѤ뤿˥󥯥롼

using namespace std ;

/**
 * @file updateParam.cc
 * @brief ħȤ
 * @param x1 x2 бȤǼ٥
 * @param x1_hat x2_hat x1_tilde x2_tilde бȤ˻Ѥ٥
 * @param Xi V_0 бȤ˻Ѥ٥
 * @param u ùɽ 9 ٥ȥ
 * @author Kento YAMADA
 * @date 2008.6.19
 */
void updateParam( vector< VecC > &x1, vector< VecC > &x2,
                  vector< VecC > &x1_hat, vector< VecC > &x2_hat,
                  vector< VecC > &x1_tilde, vector< VecC > &x2_tilde,
                  const vector< VecC > &xi, const vector< Mat > &V_0,
                  const VecC u ) {

  unsigned int N = x1.size() ;  //!< ħο \alpha
  double u_xi ;
  VecC V1(3), V2(3) ;
  Mat U1(2,3), U2(2,3) ;


  /* STEP 04 */
  /* \tilde{x_\alpha} \tilde{y_\alpha}
   * \tilde{x_\alpha}^\prime tilde{y_\alpha}^\prime ͤ򹹿*/
  U1[0][0] = u[0];  U1[0][1] = u[1];  U1[0][2] = u[2];
  U1[1][0] = u[3];  U1[1][1] = u[4];  U1[1][2] = u[5];
  U2[0][0] = u[0];  U2[0][1] = u[3];  U2[0][2] = u[6];
  U2[1][0] = u[1];  U2[1][1] = u[4];  U2[1][2] = u[7];
  V1[2] = V2[2] = f ;
 
  for( unsigned int i = 0; i < N; i++ ) {
    /* frac{(\vu,\xi_\alpha)}{(\vu,\mV_0[\xi_\alpha]\vu)} η׻*/
    u_xi = (u,xi[i]) / (u,V_0[i]*u) ;
    V1[0] = x2_hat[i][0];  V1[1] = x2_hat[i][1] ;
    V2[0] = x1_hat[i][0];  V2[1] = x1_hat[i][1] ;
 
    x1_tilde[i] = u_xi * U1 * V1 ;
    x2_tilde[i] = u_xi * U2 * V2 ;
  }



  /* STEP 05 */
  /* \vu_0, \hat{x_\alpha}, \hat{x_\alpha},
   * \tilde{x_\alpha}^\prime, \tilde{x_\alpha}^\prime ͤ򹹿*/
  for( unsigned int i = 0; i < N; i++ ) {
    x1_hat[i] = x1[i] - x1_tilde[i] ;
    x2_hat[i] = x2[i] - x2_tilde[i] ;
  }

}
